Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/LocalResourceManager.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/LocalResourceManager.java	(revision 1054)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/LocalResourceManager.java	(revision 1207)
@@ -19,4 +19,5 @@
 import schedframe.resources.StandardResourceType;
 import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.ComputingResourceCharacteristics;
 import schedframe.resources.computing.ResourceCharacteristics;
 import schedframe.resources.computing.validator.ResourcePropertiesValidator;
@@ -138,5 +139,5 @@
 		for (int i = 0; i < computingResources.size() && resourceWithName == null; i++) {
 			ComputingResource resource = computingResources.get(i);
-			if (resource.getName().equals(resourceName))
+			if (resource.getFullName().equals(resourceName))
 				resourceWithName = resource;
 			else
@@ -154,5 +155,5 @@
 			while (!toExamine.isEmpty()) {
 				ComputingResource resource = toExamine.pop();
-				ResourceCharacteristics resourceCharacteristic = resource.getResourceCharacteristic();
+				ComputingResourceCharacteristics resourceCharacteristic = (ComputingResourceCharacteristics)resource.getResourceCharacteristic();
 				List<ResourceUnit> units = null;
 				units = resourceCharacteristic.getResourceUnits().get(unitName);
@@ -266,5 +267,5 @@
 		for(int i = 0 ; i < computingResources.size() && resourceWithName == null; i++){
 			ComputingResource resource = computingResources.get(i);
-			if(resource.getName().equals(resName))
+			if(resource.getFullName().equals(resName))
 				resourceWithName = resource;
 			else
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/CoolEmAllResourceType.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/CoolEmAllResourceType.java	(revision 1095)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/CoolEmAllResourceType.java	(revision 1207)
@@ -3,13 +3,21 @@
 public enum CoolEmAllResourceType implements ResourceType {
 	
-	ComputeBox2,
-	ComputeBox1,
-	NodeGroup,
-	Node,
-	Processor,
-	Core;
-
+	ComputeBox2("Room"),
+	ComputeBox1("Rack"),
+	NodeGroup("NodeGroup"),
+	Node("Node"),
+	Processor("Processor"),
+	Core("Core");
+	
+	private String label;
+	
+	CoolEmAllResourceType(String label){
+		this.label = label;
+	}
 	public String getName() {
 		return toString();
 	}
+	public String getLabel(){
+		return label;
+	}
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/ResourceTypeFactory.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/ResourceTypeFactory.java	(revision 1097)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/ResourceTypeFactory.java	(revision 1207)
@@ -5,5 +5,5 @@
 	
 	public static ResourceType createResourceType(String typeName){
-		
+
 		if(typeName.equals(StandardResourceType.Grid.getName()))
 			return StandardResourceType.Grid;
@@ -15,6 +15,6 @@
 			return StandardResourceType.Rack;
 
-		else if (typeName.equals(StandardResourceType.ComputingNode.getName()))
-			return StandardResourceType.ComputingNode;
+		else if (typeName.equals(StandardResourceType.Node.getName()))
+			return StandardResourceType.Node;
 		
 		else if (typeName.equals(StandardResourceType.Processor.getName()))
@@ -24,4 +24,7 @@
 			return StandardResourceType.Core;
 		
+		else if (typeName.equals(CoolEmAllResourceType.ComputeBox2.getName()))
+			return CoolEmAllResourceType.ComputeBox2;
+		
 		else if (typeName.equals(CoolEmAllResourceType.ComputeBox1.getName()))
 			return CoolEmAllResourceType.ComputeBox1;
@@ -30,6 +33,21 @@
 			return CoolEmAllResourceType.NodeGroup;
 		
-		else if (typeName.equals(CoolEmAllResourceType.Node.getName()))
-			return CoolEmAllResourceType.Node;
+		else if (typeName.equals(StandardResourceType.CRAH.getName()))
+			return StandardResourceType.CRAH;
+		
+		else if (typeName.equals(StandardResourceType.Fan.getName()))
+			return StandardResourceType.Fan;
+		
+		else if (typeName.equals(StandardResourceType.Inlet.getName()))
+			return StandardResourceType.Inlet;
+		
+		else if (typeName.equals(StandardResourceType.Outlet.getName()))
+			return StandardResourceType.Outlet;
+		
+		else if (typeName.equals(StandardResourceType.CoolingDevice.getName()))
+			return StandardResourceType.CoolingDevice;
+		
+		else if (typeName.equals(StandardResourceType.Heatsink.getName()))
+			return StandardResourceType.Heatsink;
 		
 		else if (typeName.equals(StandardResourceType.ResourceProvider.getName()))
@@ -42,5 +60,5 @@
 			return StandardResourceType.LS;
 		
-		else return new UserResourceType(typeName);
+		return new UserResourceType(typeName);
 	}
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/ResourceHistoryChanges.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/ResourceHistoryChanges.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/ResourceHistoryChanges.java	(revision 1207)
@@ -0,0 +1,34 @@
+package schedframe.resources;
+
+
+public class ResourceHistoryChanges {
+	
+	private long timestamp;	
+	private String resourceName;
+	private String operation;
+	private String paramter;
+	
+	public ResourceHistoryChanges(long timestamp, String resourceName, String operation, String paramter) {
+		super();
+		this.timestamp = timestamp;
+		this.resourceName = resourceName;
+		this.operation = operation;
+		this.paramter = paramter;
+	}
+	
+	public long getTimestamp() {
+		return timestamp;
+	}
+	
+	public String getResourceName() {
+		return resourceName;
+	}
+	
+	public String getOperation() {
+		return operation;
+	}
+	
+	public String getParamter() {
+		return paramter;
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/Device.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/Device.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/Device.java	(revision 1207)
@@ -0,0 +1,109 @@
+package schedframe.resources.devices;
+
+import schedframe.events.Event;
+import schedframe.events.EventHandler;
+import schedframe.events.ResourceEventCommand;
+import schedframe.events.scheduling.EventReason;
+import schedframe.events.scheduling.SchedulingEvent;
+import schedframe.resources.ResourceStatus;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.ResourceCharacteristics;
+import schedframe.resources.computing.extensions.Extension;
+import schedframe.resources.computing.extensions.ExtensionListImpl;
+import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.computing.profiles.energy.EnergyEventType;
+import schedframe.resources.computing.profiles.energy.EnergyExtension;
+import schedframe.resources.devices.description.DeviceDescription;
+
+public class Device extends PhysicalResource{
+
+	private ComputingResource compResource;
+	
+	public Device (DeviceDescription devDesc){
+		this.type = devDesc.getType();
+		this.name = devDesc.getId();
+		this.extensionList = new ExtensionListImpl(1);
+		initCharacteristics(devDesc);
+		accept(new EnergyExtension.Builder().resource(this).powerProfile(devDesc.getPowerProfile()).airFlowProfile(devDesc.getAirThroughputProfile()).thermalProfile(devDesc.getThermalProfile()).build());	
+	}
+
+	public String getFullName() {
+		
+		if(this.getResourceCharacteristic().getParameters().get("fullPath") != null){
+			String fullPath = this.getResourceCharacteristic().getParameters().get("fullPath").get(0).getContent();
+			return fullPath;
+		}
+		else 
+			return compResource.getFullName() + "/" + name;
+	}
+
+	public void setStatus(ResourceStatus newStatus) {
+		if(newStatus != status){
+			status = newStatus;
+		}
+	}
+
+	public void handleEvent(Event event) {
+		ResourceEventCommand rec = new ResourceEventCommand(this);
+		rec.execute(event);
+	}
+	
+	class DeviceEventHandler implements EventHandler{
+		
+		public void handleResourceEvent(Event event){
+			if (extensionList != null) {
+				for (Extension extension : extensionList) {
+					if (extension.supportsEvent(event)) {
+						extension.handleEvent(event);
+					}
+				}
+			}
+			if(event.getReason() != EventReason.SIM_INIT)
+				compResource.handleEvent(event);
+		}
+		
+		public void handleSchedulingEvent(SchedulingEvent event){
+
+		}
+	}
+	
+	public EventHandler getEventHandler(){
+		return new DeviceEventHandler();
+	}
+	
+	public final void initiate(){
+		
+		ResourceEventCommand rec = new ResourceEventCommand(this);
+		EnergyEvent event = new EnergyEvent(EnergyEventType.AIRFLOW_STATE_CHANGED, "Resource controller");
+		event.setReason(EventReason.SIM_INIT);
+		rec.execute(event);
+		
+		rec = new ResourceEventCommand(this);
+		event = new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, "Resource controller");
+		event.setReason(EventReason.SIM_INIT);
+		rec.execute(event);
+		
+		rec = new ResourceEventCommand(this);
+		event = new EnergyEvent(EnergyEventType.TEMPERATURE_CHANGED, "Resource controller");
+		event.setReason(EventReason.SIM_INIT);
+		rec.execute(event);
+			
+		//alternative way
+		//getEventHandler().handleResourceEvent(new EnergyEvent(EnergyEventType.AIRFLOW_STATE_CHANGED, "Resource controller"));
+		//getEventHandler().handleResourceEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, "Resource controller"));
+		//getEventHandler().handleResourceEvent(new EnergyEvent(EnergyEventType.TEMPERATURE_CHANGED, "Resource controller"));
+	}
+
+	protected void initCharacteristics(DeviceDescription devDesc){
+		resourceCharacteristic = ResourceCharacteristics.builder().location(devDesc.getLocation()).parameters(devDesc.getParameters()).build();
+	}
+
+	public void setComputingResource(ComputingResource compResource) {
+		this.compResource = compResource;
+	}
+
+	public ComputingResource getComputingResource() {
+		return compResource;
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/PhysicalResourcePowerInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/PhysicalResourcePowerInterface.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/PhysicalResourcePowerInterface.java	(revision 1207)
@@ -0,0 +1,101 @@
+package schedframe.resources.devices;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.joda.time.DateTimeUtils;
+
+import schedframe.Parameters;
+import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.computing.profiles.energy.EnergyEventType;
+import schedframe.resources.computing.profiles.energy.power.PowerProfile;
+import schedframe.resources.computing.profiles.energy.power.PowerState;
+import schedframe.resources.computing.profiles.energy.power.PowerStateName;
+import schedframe.resources.computing.profiles.energy.power.PowerUsage;
+import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
+import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
+
+public class PhysicalResourcePowerInterface implements PowerInterface{
+
+	protected PowerStateName currentPowerState;
+	protected PowerProfile powerProfile;
+	protected PhysicalResource resource;
+	
+	public PhysicalResourcePowerInterface(PhysicalResource resource, PowerProfile powerProfile){
+		this.resource = resource;
+		this.powerProfile = powerProfile;
+		this.currentPowerState = StandardPowerStateName.ON;
+	}
+	
+	public boolean setPowerState(PowerStateName state) {
+		if(supportPowerState(state)){
+			currentPowerState = state;
+
+			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getFullName()));
+
+			return true;
+		}
+		return false;
+	}
+	
+
+	public PowerStateName getPowerState() {
+		return currentPowerState;
+	}
+
+	public List<PowerState> getSupportedPowerStates() throws NoSuchFieldException {
+		List<PowerState> powerStates = new ArrayList<PowerState>();
+		for(PowerState powerState: powerProfile.getSupportedPowerStates()){
+			powerStates.add(powerState);
+		}
+		return powerStates;
+	}
+
+	public boolean supportPowerState(PowerStateName state) {
+		for(PowerState powerState: powerProfile.getSupportedPowerStates()){
+			if(powerState.getName().equals(state)){
+				return true;
+			}
+		}
+		return false;
+		
+	}
+	
+	public double getPowerConsumption(PowerStateName state) throws NoSuchFieldException {
+		double powerConsumption = 0;
+		if(supportPowerState(state)){
+			for(PowerState powerState: powerProfile.getSupportedPowerStates()){
+				if(powerState.getName().equals(state)){
+					powerConsumption = powerState.getPowerUsage();
+					break;
+				}
+			}
+		} else {
+			throw new NoSuchFieldException("Power state not supported");
+		}
+		return powerConsumption;
+	}
+
+	public PowerUsage getRecentPowerUsage() {
+		PowerUsage powerUsage = null;
+		int lastIdx = getPowerUsageHistory().size() - 1;
+		if(lastIdx >= 0)
+			powerUsage = getPowerUsageHistory().get(lastIdx);
+		else {	
+			try {
+				powerUsage = new PowerUsage(DateTimeUtils.currentTimeMillis(), getPowerConsumption(currentPowerState));
+			} catch (NoSuchFieldException e) {
+			}
+		}
+		return powerUsage;
+	}
+	
+	public List<PowerUsage> getPowerUsageHistory(){
+		return powerProfile.getPowerUsageHistory();
+	}
+	
+	public Parameters getParameters() {
+		return powerProfile.getParameters();
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/PhysicalResourceThermalInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/PhysicalResourceThermalInterface.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/PhysicalResourceThermalInterface.java	(revision 1207)
@@ -0,0 +1,43 @@
+package schedframe.resources.devices;
+
+import java.util.List;
+
+import org.joda.time.DateTimeUtils;
+
+import schedframe.Parameters;
+import schedframe.resources.computing.profiles.energy.thermal.TemperatureValue;
+import schedframe.resources.computing.profiles.energy.thermal.ThermalProfile;
+import schedframe.resources.computing.profiles.energy.thermal.ui.ThermalInterface;
+
+public class PhysicalResourceThermalInterface implements ThermalInterface{
+
+	private static int START_TEMP = 0;
+	protected PhysicalResource resource;
+	protected ThermalProfile thermalProfile;
+
+	public PhysicalResourceThermalInterface(PhysicalResource resource, ThermalProfile thermalProfile) {
+		super();
+		this.resource = resource;
+		this.thermalProfile = thermalProfile;
+	}
+
+	public TemperatureValue getRecentTemperature() {
+		TemperatureValue temperature = null;
+		int lastIdx = getTemperatureHistory().size() - 1;
+		if(lastIdx >= 0)
+			temperature = getTemperatureHistory().get(lastIdx);
+		else {	
+			temperature = new TemperatureValue(DateTimeUtils.currentTimeMillis(), START_TEMP);
+		}
+		return temperature;
+	}
+
+	public List<TemperatureValue> getTemperatureHistory() {
+		return thermalProfile.getTemperatureHistory();
+	}
+
+	public Parameters getParameters() {
+		return thermalProfile.getParameters();
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/description/PhysicalResourceDescription.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/description/PhysicalResourceDescription.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/description/PhysicalResourceDescription.java	(revision 1207)
@@ -0,0 +1,262 @@
+package schedframe.resources.devices.description;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import schedframe.Parameter;
+import schedframe.Parameters;
+import schedframe.Property;
+import schedframe.resources.ResourceType;
+import schedframe.resources.computing.description.ResourceDescription;
+import schedframe.resources.computing.location.Location;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputProfile;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputState;
+import schedframe.resources.computing.profiles.energy.airthroughput.plugin.AirThroughputEstimationPlugin;
+import schedframe.resources.computing.profiles.energy.airthroughput.plugin.DefaultAirThroughputEstimationPlugin;
+import schedframe.resources.computing.profiles.energy.power.PState;
+import schedframe.resources.computing.profiles.energy.power.PowerProfile;
+import schedframe.resources.computing.profiles.energy.power.PowerState;
+import schedframe.resources.computing.profiles.energy.power.PowerStateNameFactory;
+import schedframe.resources.computing.profiles.energy.power.Transition;
+import schedframe.resources.computing.profiles.energy.power.plugin.EnergyEstimationPlugin;
+import schedframe.resources.computing.profiles.energy.thermal.ThermalProfile;
+import schedframe.resources.computing.profiles.energy.thermal.plugin.DefaultTemperatureEstimationPlugin;
+import schedframe.resources.computing.profiles.energy.thermal.plugin.TemperatureEstimationPlugin;
+import schemas.PowerUsage;
+import schemas.Profile;
+import simulator.utils.InstanceFactory;
+import example.energy.DefaultEnergyEstimationPlugin;
+
+public class PhysicalResourceDescription extends ResourceDescription{
+
+	protected PowerProfile powerProfile;
+	protected AirThroughputProfile airThroughputProfile;
+	protected ThermalProfile thermalProfile;
+	
+	protected String category;
+	protected Location location;
+	
+	public PhysicalResourceDescription(ResourceType type) {
+		super(type);
+		// TODO Auto-generated constructor stub
+	}
+
+	protected void initProfiles(Profile profile) {
+		if (profile != null) {
+			initPowerProfile(profile.getPowerProfile());
+			initAirThroughputProfile(profile.getAirThroughputProfile());
+			initThermalProfile(profile.getThermalProfile());
+		}
+	}
+	
+	protected void initPowerProfile(schemas.PowerProfile powerProfileCharacteristic) {
+		
+		if (powerProfileCharacteristic != null) {
+			EnergyEstimationPlugin energyEstimationPlugin = null;
+			List<PowerState> powerStates = null;
+			List<PState> pStates = null;
+			if(powerProfileCharacteristic.getEnergyEstimationPlugin() != null){
+				String energyEstimationPluginName = powerProfileCharacteristic.getEnergyEstimationPlugin().getName();
+				if(energyEstimationPluginName != null) {
+					energyEstimationPlugin = (EnergyEstimationPlugin) InstanceFactory.createInstance(
+							energyEstimationPluginName, EnergyEstimationPlugin.class);			
+				} else {
+					energyEstimationPlugin = new DefaultEnergyEstimationPlugin();
+				}
+				Parameters params = extractParameters(powerProfileCharacteristic.getEnergyEstimationPlugin().getParameter());
+				energyEstimationPlugin.init(params);
+			}
+			
+			if(powerProfileCharacteristic.getPowerStates() != null) {
+				powerStates = new ArrayList<PowerState>();
+				int powerStateCount = powerProfileCharacteristic.getPowerStates().getPowerStateCount();
+				for (int i = 0; i < powerStateCount ; i++) {
+					schemas.PowerState ps = powerProfileCharacteristic.getPowerStates().getPowerState(i);
+					List<Transition> transitions = new ArrayList<Transition>();
+					int transitionCount = ps.getTransitionCount();
+					for (int j = 0; j < transitionCount; j++) {
+						schemas.Transition t = ps.getTransition(j);
+						Transition transition = new Transition(PowerStateNameFactory.createPowerStateName(t.getTo()), t
+								.getPowerUsage().getContent(), t.getTime().getContent());
+						Parameters params = extractParameters(t.getParameter());
+						transition.init(params);
+						transitions.add(transition);
+					}
+					//CoolEmAll DEBB description case
+					if(ps.getPowerUsage() == null){
+						ps.setPowerUsage(new PowerUsage("0"));
+					}
+					PowerState powerState = new PowerState(PowerStateNameFactory.createPowerStateName(ps.getName()), ps
+							.getPowerUsage().getContent(), transitions);
+					Parameters params = extractParameters(ps.getParameter());
+					powerState.init(params);
+					powerStates.add(powerState);
+				}
+			}
+			
+			if(powerProfileCharacteristic.getParameter() != null){
+				pStates = new ArrayList<PState>();
+				int parameterCount = powerProfileCharacteristic.getParameterCount();
+				for(int i = 0; i < parameterCount; i++){
+					schemas.Parameter parameter = powerProfileCharacteristic.getParameter(i);
+					if(parameter.getName().equals("pState")){
+						PState.Builder builder = new PState.Builder();
+						int propertyCount = parameter.getParameterTypeSequence().getPropertyCount();
+						for(int j = 0; j < propertyCount; j++){
+							schemas.Property property = parameter.getParameterTypeSequence().getProperty(j);
+							if(property.getName().equals("name")){
+								 builder = builder.name(property.getStringValueWithUnit(0).getContent());
+							} else if (property.getName().equals("frequency")){
+								 builder = builder.frequency(Double.valueOf(property.getStringValueWithUnit(0).getContent()));
+							} else if (property.getName().equals("voltage")){
+								builder = builder.voltage(Double.valueOf(property.getStringValueWithUnit(0).getContent()));
+							} else if (property.getName().equals("powerUsage")){
+								if(property.getStringValueWithUnit(0).getContent() != null && property.getStringValueWithUnit(0).getContent().length() > 0){
+									builder = builder.powerUsage(Double.valueOf(property.getStringValueWithUnit(0).getContent()));	
+								}
+							} else if (property.getName().equals("powerUsageMin")){
+								if(property.getStringValueWithUnit(0).getContent() != null && property.getStringValueWithUnit(0).getContent().length() > 0){
+									builder = builder.powerUsageMin(Double.valueOf(property.getStringValueWithUnit(0).getContent()));	
+								}
+							} else if (property.getName().equals("powerUsageMax")){
+								if(property.getStringValueWithUnit(0).getContent() != null && property.getStringValueWithUnit(0).getContent().length() > 0){
+									builder = builder.powerUsageMax(Double.valueOf(property.getStringValueWithUnit(0).getContent()));	
+								}
+							}else if (property.getName().equals("loadPowerUsage")){
+								if(property.getStringValueWithUnit(0).getContent() != null && property.getStringValueWithUnit(0).getContent().length() > 0 &&
+										property.getStringValueWithUnit(1).getContent() != null && property.getStringValueWithUnit(1).getContent().length() > 0){
+									//LoadPowerUsage lpu = new LoadPowerUsage(Double.valueOf(property.getStringValueWithUnit(0).getContent()), Double.valueOf(property.getStringValueWithUnit(1).getContent()));
+									//builder = builder.loadPowerUsage(lpu);
+									builder.loadPowerUsage(Double.valueOf(property.getStringValueWithUnit(0).getContent()), Double.valueOf(property.getStringValueWithUnit(1).getContent()));
+								}
+							}
+						}
+						PState pState = builder.build();
+						pStates.add(pState);
+					}
+				}	
+			}
+			this.powerProfile = new PowerProfile(energyEstimationPlugin, powerStates, pStates);
+			Parameters params = extractParameters(powerProfileCharacteristic.getParameter());
+			this.powerProfile.init(params);
+		}
+	}
+
+	protected void initAirThroughputProfile(schemas.AirThroughputProfile airThroughputProfile) {
+		if (airThroughputProfile != null) {
+			
+			AirThroughputEstimationPlugin airThroughputEstimationPlugin = null;
+			List<AirThroughputState> airThroughputStates = null;
+			if(airThroughputProfile.getAirThroughputEstimationPlugin() != null){
+				String airThroughputEstimationPluginName = airThroughputProfile.getAirThroughputEstimationPlugin().getName();
+				if(airThroughputEstimationPluginName != null) {
+					airThroughputEstimationPlugin = (AirThroughputEstimationPlugin) InstanceFactory.createInstance(
+							airThroughputEstimationPluginName, AirThroughputEstimationPlugin.class);			
+				} else {
+					airThroughputEstimationPlugin = new DefaultAirThroughputEstimationPlugin();
+				}
+				Parameters params = extractParameters(airThroughputProfile.getAirThroughputEstimationPlugin().getParameter());
+				airThroughputEstimationPlugin.init(params);
+			}
+			if(airThroughputProfile.getAirThroughputStates() != null){
+				airThroughputStates = new ArrayList<AirThroughputState>();
+				int airThrouhputStateCount = airThroughputProfile.getAirThroughputStates().getAirThroughputStateCount();
+				for (int i = 0; i < airThrouhputStateCount; i++) {
+					schemas.AirThroughputState ats = airThroughputProfile.getAirThroughputStates().getAirThroughputState(i);
+					AirThroughputState airThroughputState = new AirThroughputState(ats.getName(), ats.getValue()
+							.getContent(), ats.getPowerUsage().getContent());
+					Parameters params = extractParameters(ats.getParameter());
+					airThroughputState.init(params);
+					airThroughputStates.add(airThroughputState);
+				}
+			}
+			this.airThroughputProfile = new AirThroughputProfile(airThroughputEstimationPlugin, airThroughputStates);
+			Parameters params = extractParameters(airThroughputProfile.getParameter());
+			this.airThroughputProfile.init(params);
+		}
+	}
+	
+	protected void initThermalProfile(schemas.ThermalProfile thermalProfile) {
+		
+		if (thermalProfile != null) {
+			
+			TemperatureEstimationPlugin temperatureEstimationPlugin = null;
+
+			if(thermalProfile.getTemperatureEstimationPlugin() != null){
+				String temperatureEstimationPluginName = thermalProfile.getTemperatureEstimationPlugin().getName();
+				if(temperatureEstimationPluginName != null) {
+					temperatureEstimationPlugin = (TemperatureEstimationPlugin) InstanceFactory.createInstance(
+							temperatureEstimationPluginName, TemperatureEstimationPlugin.class);			
+				} else {
+					temperatureEstimationPlugin = new DefaultTemperatureEstimationPlugin();
+				}
+				Parameters params = extractParameters(thermalProfile.getTemperatureEstimationPlugin().getParameter());
+				temperatureEstimationPlugin.init(params);
+			}
+			this.thermalProfile = new ThermalProfile();
+			Parameters params = extractParameters(thermalProfile.getParameter());
+			this.thermalProfile.init(params);
+		}
+	}
+	
+	protected void initLocation(schemas.Location l) {
+		if (location != null) {
+			this.location = new Location(l.getHorizontal(), l.getVertical(), l.getDepth());
+			Parameters params = extractParameters(l.getParameter());
+			this.location.init(params);
+		}
+	}
+
+	protected Parameters extractParameters(schemas.Parameter[] parameters){
+		
+		Parameters params = null;
+		
+		if(parameters.length != 0)
+			params = new Parameters();
+		
+		for(int i = 0; i < parameters.length; i++){
+			schemas.Parameter parameter = parameters[i];
+			Parameter param = new Parameter(parameter.getName());
+			if(parameter.getParameterTypeSequence() != null && parameter.getParameterTypeSequence().getProperty() != null)
+			{							
+				int propertyCount = parameter.getParameterTypeSequence().getPropertyCount();
+				for(int j = 0; j < propertyCount; j++){
+					schemas.Property property = parameter.getParameterTypeSequence().getProperty(j);
+					Property prop = new Property(property.getName());
+					int stringValueWithUnitCount = property.getStringValueWithUnitCount();
+					for(int k = 0; k < stringValueWithUnitCount; k++){
+						prop.add(property.getStringValueWithUnit(k));
+					}
+					param.addProperty(prop);
+				}
+			} else {
+				int stringValueWithUnitCount =  parameter.getStringValueWithUnitCount();
+				for(int j = 0; j < stringValueWithUnitCount; j++){
+					param.add(parameter.getStringValueWithUnit(j));
+				}
+			}
+			params.put(parameter.getName(), param);
+		}
+		return params;
+	}
+	
+	public PowerProfile getPowerProfile() {
+		return powerProfile;
+	}
+
+	public AirThroughputProfile getAirThroughputProfile() {
+		return airThroughputProfile;
+	}
+
+	public ThermalProfile getThermalProfile() {
+		return thermalProfile;
+	}
+	
+	public Location getLocation() {
+		return location;
+	}
+	
+	public String getCategory() {
+		return category;
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/description/DeviceDescription.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/description/DeviceDescription.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/description/DeviceDescription.java	(revision 1207)
@@ -0,0 +1,31 @@
+package schedframe.resources.devices.description;
+
+import schedframe.resources.ResourceTypeFactory;
+import schedframe.resources.utils.ResourceIdGenerator;
+
+public class DeviceDescription extends PhysicalResourceDescription{
+	
+	
+	public DeviceDescription(schemas.Device device) {
+
+		super(ResourceTypeFactory.createResourceType(device.getClazz()));
+		this.category = device.getType();
+		
+		initId(device);
+
+		if (device.getDeviceTypeChoiceSequence() != null) {
+			initProfiles(device.getDeviceTypeChoiceSequence().getProfile());
+			initLocation(device.getDeviceTypeChoiceSequence().getLocation());
+			this.parameters = extractParameters(device.getDeviceTypeChoiceSequence().getParameter());
+		}
+	}
+
+	private void initId(schemas.Device device){
+		this.id = device.getName() != null ? device.getName() : type.getName();
+		if(device.getCount() > 1 || device.getName() == null){
+			this.id = id + "_" + String.valueOf(ResourceIdGenerator.getId(type.getName()));
+		}
+	}
+	
+
+}
